int? compare(a, b) {
  final result = _compare(a, b);
  return (result != 0) ? result : null;
}

int _compare(a, b) {
  if(a == b) {
    return 0;
  }
  if(a != null && b != null) {
    if(a is Iterable && b is Iterable) {
      return _compareIterables(a, b);
    }
    if(a is Map && b is Map) {
      return _compareMaps(a, b);
    }
    if(a.runtimeType == b.runtimeType) {
      if(a is Comparable) return a.compareTo(b);
      return '$a'.compareTo('$b');
    }
    return 0;
  }
  return (a != null) ? 1 : -1;
}

int _compareIterables(Iterable a, Iterable b) {
  final iA = a.iterator, iB = b.iterator;
  while(true) {
    final mA = iA.moveNext(), mB = iB.moveNext();
    if(mA == false && mB == false) {
      return 0;
    }
    final vA = mA ? iA.current : null, vB = mB ? iB.current : null;
    final r = _compare(vA, vB);
    if(r != 0) {
      return r;
    }
  }
}

int _compareMaps(Map a, Map b) {
  return compare(a.keys, b.keys) ?? compare(a.values, b.values) ?? 0;
}