import 'package:oobium_datastore/src/compare.dart';
import 'package:test/test.dart';

void main() {
  test('test nulls', () {
    expect(compare(null, null), isNull);
  });

  test('test null.compareTo(any)', () {
    expect(compare(null, 0), -1);
    expect(compare(null, -1), -1);
    expect(compare(null, 1), -1);
    expect(compare(null, '1'), -1);
    expect(compare(null, Object()), -1);
    expect(compare(null, Object), -1);
  });

  test('test any.compareTo(null)', () {
    expect(compare(0, null), 1);
    expect(compare(-1, null), 1);
    expect(compare(1, null), 1);
    expect(compare('1', null), 1);
    expect(compare(Object(), null), 1);
    expect(compare(Object, null), 1);
  });

  test('test number.compareTo(notNumber)', () {
    expect(compare(1, '1'), isNull);
  });

  test('test number.compareTo(number)', () {
    expect(compare(1, 1), isNull);
    expect(compare(1, -1), 1);
    expect(compare(1, 2), -1);
  });

  test('test string.compareTo(string)', () {
    expect(compare('a', 'a'), isNull);
    expect(compare('b', 'a'), 1);
    expect(compare('a', 'b'), -1);
  });

  test('test iterable.compareTo(iterable)', () {
    expect(compare(['a'], ['a']), isNull);
    expect(compare(['b'], ['a']), 1);
    expect(compare(['a'], ['b']), -1);
    expect(compare(['a', 'b'], ['a', 'b']), isNull);
    expect(compare(['a', 'b'], ['a']), 1);
    expect(compare(['a'], ['a', 'b']), -1);
  });

  test('test map.compareTo(map)', () {
    expect(compare({'a':1}, {'a':1}), isNull);
    expect(compare({'b':1}, {'a':1}), 1);
    expect(compare({'a':1}, {'b':1}), -1);
    expect(compare({'a':2}, {'a':1}), 1);
    expect(compare({'a':1}, {'a':2}), -1);
    expect(compare({'a':1,'b':1}, {'a':1,'b':2}), -1);
  });
}