part of 'models_test.schema.g.dart';

class _PersistFeature extends PersistFeature {
  _PersistFeature(
      {required String path,
      required int version,
      required CompactionStrategy compactionStrategy,
      required Converter converter,
      required OnUpgrade onUpgrade})
      : super(path, version, compactionStrategy, converter, onUpgrade);

  @override
  void putRecord(DataRecord record) {
    final v = converter.decodePut(record);
    if (v is SettingsSnap)
      put(v);
    else if (v is ConfigSnap)
      put(v);
    else if (v is AccountSnap)
      put(v);
    else if (v is ImageSnap)
      put(v);
    else if (v is UserSnap)
      put(v);
    else if (v is PostSnap)
      put(v);
    else if (v is CommentSnap)
      put(v);
    else
      throw Exception('unknown type $v during PersistFeature.putRecord');
  }

  @override
  void removeRecord(DataRecord record) {
    final k = converter.decodeRemove(record);
    if (k is SettingsKey)
      remove(k);
    else if (k is ConfigKey)
      remove(k);
    else if (k is AccountKey)
      remove(k);
    else if (k is ImageKey)
      remove(k);
    else if (k is UserKey)
      remove(k);
    else if (k is PostKey)
      remove(k);
    else if (k is CommentKey)
      remove(k);
    else
      throw Exception('unknown type $k during PersistFeature.removeRecord');
  }
}
